[tool.black]
line-length = 88
target-version = ["py36", "py37", "py38"]
include = '\.pyi?$'
exclude = '''
/(
    \.git
  | \.hg
  | \.mypy_cache
  | \.tox
  | \.venv
  | \.vscode
  | _build
  | buck-out
  | build
  | dist
)/
'''

[tool.coverage.run]
branch = true

[tool.coverage.report]
exclude_lines = [
  # Have to re-enable the standard pragma
  "pragma: no cover",
  # Don't complain about missing debug-only code:
  "def __repr__",
  "if self.debug",
  # Don't complain about some magic methods:
  "def __str__",
  # Don't complain if tests don't hit defensive assertion code:
  "raise AssertionError",
  "raise NotImplementedError",
  # Don't complain if non-runnable code isn't run:
  "if 0:",
  "if __name__ == .__main__.:"
]
ignore_errors = true

[tool.isort]
combine_as_imports = true
profile = "black"
sections = "FUTURE,STDLIB,THIRDPARTY,FIRSTPARTY,LOCALFOLDER"
skip = ".eggs,.venv,venv"

[tool.poetry]
name = "aiodogstatsd"
version = "0.15.0"
description = "An asyncio-based client for sending metrics to StatsD with support of DogStatsD extension"
authors = [
    "Nikita Grishko <gr1n@protonmail.com>"
]
license = "MIT"

readme = "README.md"

homepage = "https://github.com/Gr1N/aiodogstatsd"
repository = "https://github.com/Gr1N/aiodogstatsd"
documentation = "https://gr1n.github.io/aiodogstatsd"

keywords = ["asyncio", "statsd", "statsd-client", "statsd-metrics", "dogstatsd"]

classifiers = [
    "Topic :: Software Development :: Libraries :: Python Modules"
]

[tool.poetry.dependencies]
python = "^3.6"

aiohttp = { version = ">=3.0.0", optional = true }
sanic = { version = ">=20.3.0", optional = true }
starlette = { version = ">=0.13.0", optional = true }

[tool.poetry.dev-dependencies]
async-asgi-testclient = ">=1.4"
black = { version = ">=18.9b0", allow-prereleases = true }
coverage = { version = ">=5.0", extras = ["toml"] }
flake8 = ">=3.7.6"
flake8-bugbear = ">=18.8.0"
isort = ">=5.2"
mkdocs-material = ">=4.6"
mypy = ">=0.670"
pytest = ">=4.3.0"
pytest-asyncio = ">=0.10.0"
pytest-cov = ">=2.6.1"
pytest-mock = ">=1.10.1"
pytest-mockservers = ">=0.4.0"
pytest-timeout = ">=1.3"
uvicorn = ">=0.11.2"
yarl = ">=1.3.0"

[tool.poetry.extras]
aiohttp = ["aiohttp"]
sanic = ["sanic"]
starlette = ["starlette"]

[build-system]
requires = ["poetry>=0.12"]
build-backend = "poetry.masonry.api"
